﻿Option Explicit On

Imports System.Runtime.InteropServices

Imports System.Text

'Declare Functions in the dll. The USBrelay_DLL.dll must be in the same folder as the Project or EXE.
'Also note that the values are being passed ByRef and ByVal.

Module Module1
    <DllImport("USBrelay_DLL.dll")> Public Function TestDLL(ByRef buffer As Byte) As Long
    End Function
    <DllImport("USBrelay_DLL.dll")> Public Function FindUSBrelayBoards(ByRef buffer As Byte) As Long
    End Function
    <DllImport("USBrelay_DLL.dll")> Public Function GetManufacturerString(ByVal ID As Integer, ByRef buffer As Byte) As Long
    End Function
    <DllImport("USBrelay_DLL.dll")> Public Function GetProductString(ByVal ID As Integer, ByRef buffer As Byte) As Long
    End Function
    <DllImport("USBrelay_DLL.dll")> Public Function GetVersionString(ByVal ID As Integer, ByRef buffer As Byte) As Long
    End Function
    <DllImport("USBrelay_DLL.dll")> Public Function ReadUSBrelays(ByVal ID As Integer, ByRef buffer As Byte) As Long
    End Function
    <DllImport("USBrelay_DLL.dll")> Public Function WriteUSBrelay(ByVal ID As Integer, ByVal Command As Integer, ByVal LEDS As Integer) As Long
    End Function

    'Make a 1024 byte buffer that gets filled by the USBrelay_DLL.dll
    Public buffer(1024) As Byte
    'Global variable that holds the first usb relay board found
    Public USBrelayFound As String

End Module



Public Class Form1

    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
        TextBox1.Text = "(C)opyright 2011 EtherTek Circuits"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        'call the TestDLL function.
        'Returns the OK String unless there is an error.
        Dim sdbuffer As String
        Dim errnum As Long
        Dim xx As Integer
        sdbuffer = ""
        errnum = TestDLL(buffer(0))
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If
        For xx = 0 To 1023
            sdbuffer = sdbuffer & Chr(buffer(xx))
        Next
        TextBox1.Text = TextBox1.Text & sdbuffer
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        'call the FindUSBrelayBoards function.
        'Returns a list of Relay Boards found unless there is an error.
        Dim sdbuffer As String
        Dim errnum As Long
        Dim xx As Integer
        Dim ID As Integer
        Dim sdByte As Byte
        sdbuffer = ""
        errnum = FindUSBrelayBoards(buffer(0))
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If
        For xx = 0 To 3
            sdbuffer = sdbuffer & Chr(buffer(xx))
        Next
        TextBox1.Text = TextBox1.Text & sdbuffer
        TextBox1.Text = TextBox1.Text & vbCrLf
        USBrelayFound = sdbuffer
        Button3.Enabled = True
        Button4.Enabled = True
        Button5.Enabled = True
        Button6.Enabled = True
        Button7.Enabled = True
        Button8.Enabled = True
        Button9.Enabled = True
        Button10.Enabled = True
        Button11.Enabled = True
        Button12.Enabled = True
        Button13.Enabled = True
        Button14.Enabled = True
        Button15.Enabled = True
        Button16.Enabled = True
        Button2.Enabled = False
        CheckBox1.Enabled = True
        CheckBox2.Enabled = True
        CheckBox3.Enabled = True
        CheckBox4.Enabled = True
        CheckBox5.Enabled = True
        CheckBox6.Enabled = True

        'call the ReadUSBrelays function.
        'Returns Relay Board info unless there is an error.
        sdbuffer = ""
        ID = CLng("&H" & USBrelayFound)
        errnum = ReadUSBrelays(ID, buffer(0))
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        'parse out 4 firmware version bytes example: 1.00
        sdbuffer = Chr(buffer(7))
        sdbuffer = sdbuffer & Chr(buffer(8))
        sdbuffer = sdbuffer & Chr(buffer(9))
        sdbuffer = sdbuffer & Chr(buffer(10))

        'set firmware text box
        TextBox2.Text = sdbuffer

        sdbuffer = ""
        'byte 6 is LED status byte
        sdByte = buffer(6)
        If sdByte And 1 Then
            CheckBox1.Checked = True
        Else
            CheckBox1.Checked = False
        End If

        If sdByte And 2 Then
            CheckBox2.Checked = True
        Else
            CheckBox2.Checked = False
        End If

        If sdByte And 4 Then
            CheckBox3.Checked = True
        Else
            CheckBox3.Checked = False
        End If

        If sdByte And 8 Then
            CheckBox4.Checked = True
        Else
            CheckBox4.Checked = False
        End If

        If sdByte And 16 Then
            CheckBox5.Checked = True
        Else
            CheckBox5.Checked = False
        End If

        If sdByte And 32 Then
            CheckBox6.Checked = True
        Else
            CheckBox6.Checked = False
        End If

    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        'call the GetManufacturerString function.
        'Returns the Manufacturer String unless there is an error.
        Dim sdbuffer As String
        Dim errnum As Long
        Dim xx As Integer
        Dim ID As Integer
        sdbuffer = ""
        ID = CLng("&H" & USBrelayFound)
        errnum = GetManufacturerString(ID, buffer(0))
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        For xx = 0 To 1023
            sdbuffer = sdbuffer & Chr(buffer(xx))
        Next

        TextBox1.Text = TextBox1.Text & sdbuffer
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
        'call the GetProductString function.
        'Returns the Product String unless there is an error.
        Dim sdbuffer As String
        Dim errnum As Long
        Dim xx As Integer
        Dim ID As Integer
        sdbuffer = ""
        ID = CLng("&H" & USBrelayFound)
        errnum = GetProductString(ID, buffer(0))
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        For xx = 0 To 1023
            sdbuffer = sdbuffer & Chr(buffer(xx))
        Next

        TextBox1.Text = TextBox1.Text & sdbuffer
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button5_Click(sender As System.Object, e As System.EventArgs) Handles Button5.Click
        'call the GetVersionString function.
        'Returns the Version String unless there is an error.
        Dim sdbuffer As String
        Dim errnum As Long
        Dim xx As Integer
        Dim ID As Integer
        sdbuffer = ""
        ID = CLng("&H" & USBrelayFound)
        errnum = GetVersionString(ID, buffer(0))
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        For xx = 0 To 1023
            sdbuffer = sdbuffer & Chr(buffer(xx))
        Next

        TextBox1.Text = TextBox1.Text & sdbuffer
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button6_Click(sender As System.Object, e As System.EventArgs) Handles Button6.Click
        'call the WriteUSBrelay function.
        'Energizes Relay 1 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer
        
        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 1, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 1 ON"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button7_Click(sender As System.Object, e As System.EventArgs) Handles Button7.Click
        'call the WriteUSBrelay function.
        'De-Energizes Relay 1 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 0, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 1 OFF"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button8_Click(sender As System.Object, e As System.EventArgs) Handles Button8.Click
        'call the WriteUSBrelay function.
        'Energizes Relay 2 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 3, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 2 ON"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button9_Click(sender As System.Object, e As System.EventArgs) Handles Button9.Click
        'call the WriteUSBrelay function.
        'De-Energizes Relay 2 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 2, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 2 OFF"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button10_Click(sender As System.Object, e As System.EventArgs) Handles Button10.Click
        'call the WriteUSBrelay function.
        'Energizes Relay 3 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 5, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 3 ON"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button11_Click(sender As System.Object, e As System.EventArgs) Handles Button11.Click
        'call the WriteUSBrelay function.
        'De-Energizes Relay 3 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 4, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 3 OFF"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button12_Click(sender As System.Object, e As System.EventArgs) Handles Button12.Click
        'call the WriteUSBrelay function.
        'Energizes Relay 4 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 7, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 4 ON"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button13_Click(sender As System.Object, e As System.EventArgs) Handles Button13.Click
        'call the WriteUSBrelay function.
        'De-Energizes Relay 4 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 6, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 4 OFF"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button14_Click(sender As System.Object, e As System.EventArgs) Handles Button14.Click
        'call the WriteUSBrelay function.
        'Energizes Relay 5 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 9, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 5 ON"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button15_Click(sender As System.Object, e As System.EventArgs) Handles Button15.Click
        'call the WriteUSBrelay function.
        'De-Energizes Relay 5 unless there is an error.
        Dim errnum As Long
        Dim ID As Integer

        ID = CLng("&H" & USBrelayFound)
        errnum = WriteUSBrelay(ID, 8, 0)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "Relay 5 OFF"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button16_Click(sender As System.Object, e As System.EventArgs) Handles Button16.Click
        'call the WriteUSBrelay function.
        'send LED status unless there is an error.
        Dim errnum As Long
        Dim ID As Integer
        Dim LED As Integer

        ID = CLng("&H" & USBrelayFound)

        LED = 0

        If CheckBox1.Checked = True Then
            LED = LED Or 1
        End If

        If CheckBox2.Checked = True Then
            LED = LED Or 2
        End If

        If CheckBox3.Checked = True Then
            LED = LED Or 4
        End If

        If CheckBox4.Checked = True Then
            LED = LED Or 8
        End If

        If CheckBox5.Checked = True Then
            LED = LED Or 16
        End If

        If CheckBox6.Checked = True Then
            LED = LED Or 32
        End If

        errnum = WriteUSBrelay(ID, 11, LED)
        If errnum = 0 Then
            TextBox1.Text = "ERROR Function Call Failed"
            TextBox1.Text = TextBox1.Text & vbCrLf
            Exit Sub
        End If

        TextBox1.Text = TextBox1.Text & "LED info sent"
        TextBox1.Text = TextBox1.Text & vbCrLf
    End Sub

    Private Sub Button17_Click(sender As System.Object, e As System.EventArgs) Handles Button17.Click
        MsgBox("USB Relay Boad Visual Basic 2010 Example", MsgBoxStyle.Information, "About USB Relay Example")

    End Sub


    Private Sub Button18_Click(sender As System.Object, e As System.EventArgs) Handles Button18.Click
        End
    End Sub


End Class
